/*******************************************************************************




			T R A N S P . C P P
			-----------------

Rev 08/12/98
********************************************************************************


	--transp-- Ce module permet de dessin d'une bmp transparente


*******************************************************************************/

#include <windows.h>
#include <wingdi.h>
#include "transp.h"


// colors
#define rgbBlack RGB(0,0,0)
#define rgbWhite RGB(255,255,255)



int LoadTransparentBmp( HANDLE hInst, HWND hWnd, int nBmp, int nBkTransp )
    {
    HDC hdcDestination, hdcBitmapSrc ;
    HBITMAP hbmBitmapSrc, hbmOldBitmap ;
    BITMAP bm;
    RECT rcClient;
    COLORREF OldBkColor ;
    int x, y;
    PAINTSTRUCT ps;
    
    BeginPaint(hWnd, &ps);

    hdcDestination = ps.hdc ;
    //----------------------------------------------------------------
    //  On charge le dessin du bitmap
    //----------------------------------------------------------------
    hbmBitmapSrc = LoadBitmap( (HINSTANCE)hInst, MAKEINTRESOURCE(nBmp));
    if (!hbmBitmapSrc)
	return 0 ;
    //----------------------------------------------------------------
    //	On recupere des info sur la taille de la fentre et du bitmap
    //	pour les coordonne et taille de la copy du bitmap
    //----------------------------------------------------------------
    GetObject(hbmBitmapSrc, sizeof(bm), (LPSTR)&bm);
    GetClientRect(hWnd, &rcClient);
    x = (rcClient.right - rcClient.left - bm.bmWidth) / 2 + rcClient.left;
    y = (rcClient.bottom - rcClient.top - bm.bmHeight) / 2 + rcClient.top;
    //-----------------------------------------------------------------
    //	Preparation du DC de source pour le Bitblit
    //-----------------------------------------------------------------
    hdcBitmapSrc = CreateCompatibleDC(hdcDestination);
    hbmOldBitmap = (HBITMAP)SelectObject(hdcBitmapSrc, hbmBitmapSrc);
    //------------------------------------------------------------------
    //  Il faut selection la couleur qui doit devenir transparante
    //  Dans le bitmap. Cette couleur est la couleur de fond du dc de
    //  destination.
    //-------------------------------------------------------------------
    OldBkColor = SetBkColor(hdcDestination, nBkTransp);
    TransBlt(hdcDestination, 
	   x,
	   y,
	   bm.bmWidth,
	   bm.bmHeight,
	   hdcBitmapSrc,
	   0, 0);
    //------------------------------------------------------------------
    //	Ici on fait monsieur propes
    //------------------------------------------------------------------
    SelectObject(hdcBitmapSrc, hbmOldBitmap);
    DeleteDC	(hdcBitmapSrc);
    DeleteObject(hbmBitmapSrc);

    SetBkColor(hdcDestination, OldBkColor); // transparency color is BLUE

    EndPaint(hWnd, &ps);
    return 1;
    }

/*
 *
 * TransBlt() Transparent bitblt that uses the current
 *            background color of the DC as the transparent color.
 *
 */
BOOL TransBlt (HDC hdcD,int x,int y,int dx,int dy,HDC hdcS,int x0,int y0)
    {
    DWORD       rgbBk,rgbFg;
    DWORD       rgbBkS;
    HBITMAP         hbmMask;
    HDC         hdcMask;
    HBITMAP         hbmT;
    BOOL        f = FALSE;

    //
    //  Get the current DC color's
    //
    rgbBk = GetBkColor(hdcD);
    rgbFg = GetTextColor(hdcD);
    rgbBkS= GetBkColor(hdcS);

    SetTextColor(hdcD,rgbBlack);

    //
    //  make a memory DC for use in color conversion
    //
    hdcMask = CreateCompatibleDC(hdcS);

    if (!hdcMask)
        return FALSE;

    //
    // create a mask bitmap and associated DC
    //
    hbmMask = CreateBitmap(dx, dy, 1, 1, NULL);

    if (!hbmMask)
        goto errorDC;

    // select the mask bitmap into the mono DC

    hbmT = (HBITMAP)SelectObject(hdcMask, hbmMask);

    // do a color to mono bitblt to build the mask
    // generate 1's where the source is equal to the background, else 0's

    SetBkColor(hdcS, rgbBk);
    BitBlt(hdcMask, 0, 0, dx, dy, hdcS, x0, y0, SRCCOPY);

    // do a MaskBlt to copy the bitmap to the dest

    SetBkColor(hdcD,rgbWhite);
    BitBlt(hdcD,x,y,dx,dy,hdcS,   x0,y0,SRCINVERT);
    BitBlt(hdcD,x,y,dx,dy,hdcMask,0 ,0 ,SRCAND);
    BitBlt(hdcD,x,y,dx,dy,hdcS,   x0,y0,SRCINVERT);

    f = TRUE;

    SelectObject(hdcMask, hbmT);
    DeleteObject(hbmMask);

    //
    // Restore the DC colors
    //
    SetBkColor(hdcS,rgbBkS);
    SetBkColor(hdcD,rgbBk);
    SetTextColor(hdcD,rgbFg);

errorDC:
    DeleteDC(hdcMask);

    return f;
    }




/*---------------------------------------------------------------------------
**
**        PAINTTRANSBITMAP
**---------------------------------------------------------------------------
**
**  DESCRIPTION
**        --PaintTransBitmap--
**  ARGUMENTS
**        Argument1:  HBITMAP hbmBitmapSrc
**        Argument2: HDC hdcDestination
**        Argument3: int x
**        Argument4: int y
**  RETOUR/RESULTAT
**        void 
**  DIAGNOSTIC
**  IMPLEMENTATION
**  REMARQUE
**  Rev 02/03/99 
**--------------------------------------------------------------------------*/
void PaintTransBitmap( HBITMAP hbmBitmapSrc, HDC hdcDestination,int x,int y, int nBkTransp )
    {
    HDC hdcBitmapSrc ;
    HBITMAP hbmOldBitmap ;
    BITMAP bm;
    COLORREF OldBkColor ;

    //----------------------------------------------------------------
    //	On recupere des info sur la taille du bitmap
    //----------------------------------------------------------------
    GetObject(hbmBitmapSrc, sizeof(bm), (LPSTR)&bm);

    //-----------------------------------------------------------------
    //	Preparation du DC de source pour le Bitblit
    //-----------------------------------------------------------------
    hdcBitmapSrc = CreateCompatibleDC(hdcDestination);
    hbmOldBitmap = (HBITMAP)SelectObject(hdcBitmapSrc, hbmBitmapSrc);
    //------------------------------------------------------------------
    //  Il faut selection la couleur qui doit devenir transparante
    //  Dans le bitmap. Cette couleur est la couleur de fond du dc de
    //  destination.
    //-------------------------------------------------------------------
    OldBkColor = SetBkColor(hdcDestination, nBkTransp);
    TransBlt(hdcDestination, 
	   x,
	   y,
	   bm.bmWidth,
	   bm.bmHeight,
	   hdcBitmapSrc,
	   0, 0);

    //------------------------------------------------------------------
    //	Ici on fait monsieur propes
    //------------------------------------------------------------------
    SelectObject(hdcBitmapSrc, hbmOldBitmap);
    DeleteDC	(hdcBitmapSrc);

    SetBkColor(hdcDestination, OldBkColor); 

    }